;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Definition of the functions inds_<List_T> and elems_<List_T>
;; List_Set_T-template.smt

 :extrafuns ((inds_<List_T> <List_T> Set_Int)
             (elems_<List_T> <List_T> Set_<T>))

 :assumption (forall (?x <List_T>) (?y Int)
                     (iff (= (select (embed_Set_Int__Array (inds_<List_T> ?x))
                                     (embed_Int__Int ?y))
                             Set_elem)
                          (and (>= ?y 1) (<= ?y (length_<List_T> ?x))))
              :pat { (select (embed_Set_Int__Array (inds_<List_T> ?x))
                             (embed_Int__Int ?y)) })

 :assumption (= (elems_<List_T> nil_<List_T>) emptySet_<Set_T>)

 :assumption (forall (?x <List_T>) (?y <T>)
                     (= (elems_<List_T> (cons_<List_T> ?y ?x))
                        (insert_<Set_T> ?y (elems_<List_T> ?x)))
              :pat { (elems_<List_T> (cons_<List_T> ?y ?x)) })

 :assumption (forall (?x <List_T>) (?y <List_T>)
                     (= (elems_<List_T> (append_<List_T> ?x ?y))
                        (union_<Set_T> (elems_<List_T> ?x) (elems_<List_T> ?y)))
              :pat { (elems_<List_T> (append_<List_T> ?x ?y)) })

;; End: Definition of the functions inds_<List_T> and elems_<List_T>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
